Bug 1249473 - Review Request: txr - An original, new programming language for convenient data munging
Review Request: txr - An original, new programming language for convenient da...
Status: ASSIGNED
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nikola Forró
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-08-03 02:47 EDT by Christopher Meng
Modified: 2015-09-02 06:45 EDT (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
nforro: fedora‑review?


Attachments (Terms of Use)

  None (edit)
Description Christopher Meng 2015-08-03 02:47:38 EDT
Spec URL: http://cicku.me/txr.spec
SRPM URL: http://cicku.me/txr-110-1.fc24.src.rpm
Description: TXR is a pragmatic, convenient tool ready to take on your daily hacking challenges with its dual personality: its whole-document pattern matching and extraction language for scraping information from arbitrary text sources, and its powerful data-processing language to slice through problems like a hot knife through butter. Many tasks can be accomplished with TXR "one liners" directly from your system prompt.
Fedora Account System Username: cicku
Comment 1 Nikola Forró 2015-08-21 10:40:44 EDT
I'm not sure about the license. The author claims it's equal to BSD, but there are some differences. It might be best to ask on "legal" mailing list.

There is duplicate LICENSE file in the package. Marking relative path with %license causes it to be installed to %{_defaultlicensedir}/%{name}, but the file is already installed in %{_datadir}/%{name}.

Here is rpmlint output:

txr.spec:25: W: configure-without-libdir-spec
txr.src:25: W: configure-without-libdir-spec

This is fine, as the configure script does not support --libdir and there are no libraries built.

txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 4458: warning: macro `con' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 4559: warning: macro `cod' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 8277: warning: macro `srn' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 8443: warning: macro `ocde' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 9230: warning: macro `<qq-template>' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 11657: warning: macro `mode' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 11667: warning: macro `modn' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 14403: warning: macro `coe' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 17946: warning: macro `mta' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 21484: warning: macro `metan' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 22822: warning: macro `mati' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 23108: warning: macro `ode' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 25538: warning: macro `codet' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 26376: warning: macro `codee' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 28095: warning: macro `<<form>>' not defined

This is fixed in latest upstream release, so please update to it.
Comment 2 Nikola Forró 2015-09-01 09:35:20 EDT
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[?]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[?]: License field in the package spec file matches the actual license.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 870400 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[!]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[-]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
     Note: Arch-ed rpms have a total of 1177600 bytes in /usr/share
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: txr-110-1.fc24.x86_64.rpm
          txr-110-1.fc24.src.rpm
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 4458: warning: macro `con' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 4559: warning: macro `cod' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 8277: warning: macro `srn' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 8443: warning: macro `ocde' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 9230: warning: macro `<qq-template>' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 11657: warning: macro `mode' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 11667: warning: macro `modn' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 14403: warning: macro `coe' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 17946: warning: macro `mta' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 21484: warning: macro `metan' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 22822: warning: macro `mati' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 23108: warning: macro `ode' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 25538: warning: macro `codet' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 26376: warning: macro `codee' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 28095: warning: macro `<<form>>' not defined
txr.src: W: strange-permission txr-110.tar.bz2 640
txr.src:25: W: configure-without-libdir-spec
2 packages and 0 specfiles checked; 0 errors, 17 warnings.




Rpmlint (debuginfo)
-------------------
Checking: txr-debuginfo-110-1.fc24.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 4458: warning: macro `con' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 4559: warning: macro `cod' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 8277: warning: macro `srn' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 8443: warning: macro `ocde' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 9230: warning: macro `<qq-template>' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 11657: warning: macro `mode' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 11667: warning: macro `modn' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 14403: warning: macro `coe' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 17946: warning: macro `mta' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 21484: warning: macro `metan' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 22822: warning: macro `mati' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 23108: warning: macro `ode' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 25538: warning: macro `codet' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 26376: warning: macro `codee' not defined
txr.x86_64: W: manual-page-warning /usr/share/man/man1/txr.1.gz 28095: warning: macro `<<form>>' not defined
2 packages and 0 specfiles checked; 0 errors, 15 warnings.



Requires
--------
txr (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libm.so.6()(64bit)
    rtld(GNU_HASH)



Provides
--------
txr:
    txr
    txr(x86-64)



Source checksums
----------------
http://www.kylheku.com/cgit/txr/snapshot/txr-110.tar.bz2 :
  CHECKSUM(SHA256) this package     : d63a03102536a3bcc498c2c8a393e5a4408873d7265ca459489297822e631906
  CHECKSUM(SHA256) upstream package : d63a03102536a3bcc498c2c8a393e5a4408873d7265ca459489297822e631906


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1249473
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 3 Dave Love 2015-09-01 11:41:24 EDT
I don't think fixes for nroff errors are in the current release (112), just the repo.  I sent fixes for them and problems with the EPEL6 version of groff which are in https://loveshack.fedorapeople.org/copr/txr-112-1.el6.src.rpm and got referred to this packaging.

I think it's worth a note in the spec file about the licence of the bundled mpi library, whose headers are "all rights reserved"; it's easy to miss the note at the end of the METALICENSE file.  (Is it really OK to bundle mpi?)
Comment 4 Orion Poplawski 2015-09-01 11:55:28 EDT
Well the mpi README states the files are in the public domain.  And no it's not okay to bundle them without an FPC exception.  Looks like the mpi stuff is in a lot of places so this might be a rats nest to untangle.  What an unfortunate name as well.
Comment 5 Nikola Forró 2015-09-02 05:16:34 EDT
(In reply to Dave Love from comment #3)
> I don't think fixes for nroff errors are in the current release (112), just
> the repo.  I sent fixes for them and problems with the EPEL6 version of
> groff which are in
> https://loveshack.fedorapeople.org/copr/txr-112-1.el6.src.rpm and got
> referred to this packaging.
> 
Actually I meant release 113, which incorporates your fixes (thanks for that).

(In reply to Orion Poplawski from comment #4)
> Well the mpi README states the files are in the public domain.  And no it's
> not okay to bundle them without an FPC exception.  Looks like the mpi stuff
> is in a lot of places so this might be a rats nest to untangle.  What an
> unfortunate name as well.
Seems to me that mpi falls under the definition of copylib. FPC exception is definitely needed.
Comment 6 Dave Love 2015-09-02 06:45:58 EDT
(In reply to Orion Poplawski from comment #4)
> Well the mpi README states the files are in the public domain.

Yes, it's just that I missed that originally, and it's inconsistent with the actual copyright headers, so I thought a note was helpful.  The mpi source is actually patched from the original in txr-specific ways (?), and the original is apparently now only available in the txr repo.  (I'm surprised licensecheck doesn't complain at "All rights reserved".)

Note You need to log in before you can comment on or make changes to this bug.